Index: src/pkg_columnizer.cc
===================================================================
--- src/pkg_columnizer.cc	(revision 2706)
+++ src/pkg_columnizer.cc	(revision 2707)
@@ -497,13 +497,14 @@
 	     _system->VS->CheckDep(visible_ver.VerStr(), D->CompareOp, D.TargetVer()))
 	    count++;
 
-	for(pkgCache::PrvIterator i=visible_ver.ProvidesList(); !i.end(); i++)
-	  for(pkgCache::DepIterator D=i.ParentPkg().RevDependsList(); !D.end(); D++)
+	for(pkgCache::PrvIterator i=pkg.ProvidesList(); !i.end(); i++)
+	  for(pkgCache::DepIterator D=i.ParentPkg().RevDependsList(); !D.end(); D++) {
 	    if(D.IsCritical() &&
 	       D->Type!=pkgCache::Dep::Conflicts &&
 	       D.ParentVer()==D.ParentPkg().CurrentVer() &&
 	       _system->VS->CheckDep(i.ProvideVersion(), D->CompareOp, D.TargetVer()))
 	      count++;
+	  }
 	snprintf(buf, 100, "%i", count);
 	return column_disposition(buf, 0);
       }
Index: ChangeLog
===================================================================
--- ChangeLog	(revision 2706)
+++ ChangeLog	(revision 2707)
@@ -1,5 +1,9 @@
 2004-09-05  Daniel Burrows  <dburrows@debian.org>
 
+	* src/pkg_columnizer.cc:
+	  Fix crash when viewing virtual packages while using the
+	  reverse-depends-count. (Closes: #270057)
+
 	* src/vscreen/vs_table.cc:
 	  Fix several places where "focus" was dereferenced without
 	  checking whether it was valid.
